#include "FroznWar.h"
#include "fxlib.h"
#include <stdio.h>

static const unsigned char towns_bmp[192] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 4, 16, 4, 56, 14, 40, 10, 108, 27, 56, 21, 0, 53, 128, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 12, 148, 19, 34, 45, 254, 51, 34, 33, 42, 63, 42, 33, 254, 45, 0, 45, 0, 63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 224, 15, 48, 23, 152, 39, 252, 47, 132, 59, 252, 49, 164, 42, 252, 32, 252, 63, 136, 32, 136, 53, 248, 63, 128, 0, 0, 15, 240, 30, 24, 63, 12, 111, 134, 207, 255, 159, 129, 183, 161, 235, 165, 193, 255, 255, 255, 170, 255, 128, 255, 255, 130, 156, 130, 255, 254, 255, 128, 0, 0, 122, 190, 95, 246, 120, 30, 95, 246, 92, 118, 95, 246, 92, 54, 125, 126, 95, 246, 120, 30, 91, 214, 90, 214, 90, 214, 95, 246, 120, 30, 154, 169, 159, 249, 241, 143, 178, 75, 180, 43, 188, 59, 183, 235, 180, 43, 149, 121, 159, 249, 248, 15, 179, 203, 178, 203, 186, 219, 191, 251, 240, 15 };
static const unsigned char icons_bmp[64] = { 0, 0, 28, 0, 34, 112, 38, 136, 62, 152, 54, 248, 63, 216, 54, 56, 62, 120, 55, 228, 31, 108, 35, 248, 39, 96, 29, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 7, 152, 9, 152, 9, 248, 63, 252, 79, 38, 76, 38, 127, 190, 60, 220, 4, 192, 7, 192, 3, 128, 0, 0, 0, 0 };
static const unsigned char units_bmp[64] = { 3, 192, 7, 32, 15, 240, 14, 16, 13, 48, 5, 48, 4, 16, 11, 240, 16, 24, 26, 20, 39, 244, 39, 152, 31, 232, 15, 68, 17, 124, 31, 0, 7, 224, 12, 48, 14, 24, 15, 244, 13, 52, 61, 52, 60, 20, 63, 244, 50, 60, 58, 52, 55, 60, 63, 200, 25, 248, 15, 116, 23, 124, 31, 0 };

void game(void)
{
	const char *names[] = { "Campement", "Camp fortifi\xe6\x00a", "Village", "Ville", "Ch\xe6\x003teau", "Forteresse" };
	unsigned key, p = 0, level;
	char ch[20];

	while(1)
	{
		level = data.exp/100;
		if(level == 7) tuto(4), level = 6;

		Disp_Clear();
		Disp_Bitmap(towns_bmp + (level << 5),2,0,16,16,1);
		PrintXY(20,4,(const unsigned char *)names[level],0);
		PrintMini(62,19,(const unsigned char *)"Experience",0);
		Bdisp_DrawLineVRAM(60,26,122,26);
		Bdisp_DrawLineVRAM(60,25,data.exp == 600 ? 122 : 60+(data.exp%100)*62/100,25);

		Disp_Bitmap(icons_bmp,2,16,16,16,1);
		sprintf(ch,"%d",data.money);
		PrintXY(20,20,(const unsigned char *)ch,0);

		Disp_Bitmap(units_bmp,2,31,16,16,1);
		sprintf(ch,"%d",data.units[0]);
		PrintXY(20,35,(const unsigned char *)ch,0);

		Disp_Bitmap(units_bmp + 32,2,48,16,16,1);
		sprintf(ch,"%d",data.units[1]);
		PrintXY(20,51,(const unsigned char *)ch,0);

		PrintMini(72,34,(const unsigned char *)"Former :",0);
		PrintMini(60,41,(const unsigned char *)"Deblayeur (100)",0);
		PrintMini(60,48,(const unsigned char *)"Soldat (400)",0);
		PrintMini(72,56,(const unsigned char *)"Combat",0);

		SaveDisp(1);

		while(1)
		{
			tuto(1);
			RestoreDisp(1);
			Bdisp_AreaReverseVRAM(58+12*(p==2),40+7*p+(p==2),119-13*(p==1)-21*(p==2),46+7*p+(p==2));


			GetKey(&key);
			if(key == 30018 && p) p--;
			if(key == 30023 && p-2) p++;
			if(key == 30004)
			{
				if(p==0 && data.money >= 100) data.money -= 100, data.units[0]++;
				if(p==1 && data.money >= 400) data.money -= 400, data.units[1]++;
				if(p==2)
				{
					fight();
					if(!data.units[0] && !data.units[1])
					{
						tuto(5);
						save_lose();
						return;
					}
				}
				break;
			}

			save_save();
		}
	}
}

void frame(const char *s1, const char *s2, const char *s3, const char *s4, const char *s5, const char *s6)
{
	unsigned key;
	SaveDisp(3);
	PopUpWin(6);

	locate(3,2); Print((unsigned char *)s1);
	locate(3,3); Print((unsigned char *)s2);
	locate(3,4); Print((unsigned char *)s3);
	locate(3,5); Print((unsigned char *)s4);
	locate(3,6); Print((unsigned char *)s5);
	locate(3,7); Print((unsigned char *)s6);
	GetKey(&key);
	RestoreDisp(3);
}

void tuto(unsigned id)
{
	unsigned key;
	if(data.tutos[id]) return;

	switch(id)
	{
		case 0:
			frame("Bienvenue en","terre de glace.","","","","");
			frame("Vous \xe6\x0btes le chef","des arm\xe6\x00aes, mais","les monstres sont","de plus en plus","nombreux et","agressifs.");
			frame("Faites face et","construisez un","campement pour","les repousser.","","");
			frame("Attention, vos","ressources en","hommes sont","limit\xe6\x00aes.","","");
			break;

		case 1:
			frame("Voici le menu","de gestion de vos","ressources.","","","");
			frame("Vous pouvez y","voir le niveau","d'\xe6\x00avolution de","votre campement","et le contenu","de votre arm\xe6\x00ae.");
			frame("Vous pouvez aussi","y former de","nouvelles recrues","pour les envoyer","au combat.","");
			frame("Une fois que vous","\xe6\x0btes pr\xe6\x0bt, passez","\xe6\x01 l'attaque !","","","");
			break;

		case 2:
			frame("Vous voil\xe6\x01 entr\xe6\x00a","en combat.","","Placez vos unit\xe6\x00as","et partez \xe6\x01","l'assaut !");
			frame("S\xe6\x00alectionnez une","case et","choisissez","judicieusement","une unit\xe6\x00a.","");
			frame("Appuyez sur [DEL]","pour retirer une","unit\xe6\x00a.","","Une fois fini,","appuyez sur [F6].");
			break;

		case 3:
			frame("S\xe6\x00alectionnez une","unit\xe6\x00a et","validez une cible","pour attaquer !","","");
			break;

		case 4:
			frame("Bravo, vous avez","vaincu et mis","hors d'\xe6\x00atat de","nuire les","envahisseurs !","");
			frame("Vous avez apport\xe6\x00a","la paix en terre","de glace et le","peuple vous en","sera toujours","reconnaissant.");
			break;

		case 5:
			frame("Vous avez perdu","la bataille...","Les monstres ont","massacr\xe6\x00a votre","peuple et votre","heure arrive...");
	}

	data.tutos[id] = 1;
	save_save();
}
